import { ComponentStore } from '@ngrx/component-store';
import { LogType } from './models';
export type WatchComponentStateOptions = {
    logType?: LogType;
};
/**
 * Decorator used to log state of a @ngrx/component-store
 * Will create a watchState effect
 */
export default function ({ logType }?: WatchComponentStateOptions): <T extends new (...args: any[]) => ComponentStore<any>>(target: T) => {
    new (...args: any[]): {
        watchState: (observableOrValue?: void | import("rxjs").Observable<void> | undefined) => import("rxjs").Subscription;
        readonly destroySubject$: any;
        readonly destroy$: import("rxjs").Observable<void>;
        readonly stateSubject$: any;
        isInitialized: any;
        readonly state$: import("rxjs").Observable<any>;
        ɵhasProvider: any;
        ngOnDestroy(): void;
        updater<ProvidedType = void, OriginType = ProvidedType, ValueType = OriginType, ReturnType_1 = OriginType extends void ? () => void : (observableOrValue: ValueType | import("rxjs").Observable<ValueType>) => import("rxjs").Subscription>(updaterFn: (state: any, value: OriginType) => any): ReturnType_1;
        initState: any;
        setState(stateOrUpdaterFn: any): void;
        patchState(partialStateOrUpdaterFn: Partial<any> | import("rxjs").Observable<Partial<any>> | ((state: any) => Partial<any>)): void;
        get(): any;
        get<R>(projector: (s: any) => R): R;
        select<Result>(projector: (s: any) => Result, config?: import("@ngrx/component-store").SelectConfig | undefined): import("rxjs").Observable<Result>;
        select<SelectorsObject extends Record<string, import("rxjs").Observable<unknown>>>(selectorsObject: SelectorsObject, config?: import("@ngrx/component-store").SelectConfig | undefined): import("rxjs").Observable<{ [K in keyof SelectorsObject]: import("rxjs").ObservedValueOf<SelectorsObject[K]>; }>;
        select<Selectors extends import("rxjs").Observable<unknown>[], Result_1>(...selectorsWithProjector: [...selectors: Selectors, projector: import("@ngrx/component-store").Projector<Selectors, Result_1>]): import("rxjs").Observable<Result_1>;
        select<Selectors_1 extends import("rxjs").Observable<unknown>[], Result_2>(...selectorsWithProjectorAndConfig: [...selectors: Selectors_1, projector: import("@ngrx/component-store").Projector<Selectors_1, Result_2>, config: import("@ngrx/component-store").SelectConfig]): import("rxjs").Observable<Result_2>;
        effect<ProvidedType_1 = void, OriginType_1 extends unknown = import("rxjs").Observable<ProvidedType_1>, ObservableType = OriginType_1 extends import("rxjs").Observable<infer A> ? A : never, ReturnType_2 = ProvidedType_1 | ObservableType extends void ? (observableOrValue?: ObservableType | import("rxjs").Observable<ObservableType> | undefined) => import("rxjs").Subscription : (observableOrValue: ObservableType | import("rxjs").Observable<ObservableType>) => import("rxjs").Subscription>(generator: (origin$: OriginType_1) => import("rxjs").Observable<unknown>): ReturnType_2;
        checkProviderForHooks: any;
        assertStateIsInitialized: any;
    };
} & T;
